- Main Page
- Classes
- Files
- Related Pages

- Class List
- Class Hierarchy
- Class Members

# sc::ProcThreadGrp Class Reference

The ProcThreadGrp class privides a concrete thread group appropriate for an environment where there is only one thread. More...

`#include <thread.h>`

Inheritance diagram for sc::ProcThreadGrp:

List of all members.

## Public Member Functions
| ProcThreadGrp (const Ref< KeyVal > &)
int | start_threads ()
| Starts the threads running.
int | wait_threads ()
| Wait for all the threads to complete.
Ref< ThreadLock > | new_lock ()
| Return a local object.
ThreadGrp * | clone (int nthread=-1)
| Create a ThreadGrp like the current one.

## Detailed Description

The ProcThreadGrp class privides a concrete thread group appropriate for an environment where there is only one thread.

## Member Function Documentation

int sc::ProcThreadGrp::start_threads | ( |  | ) | `[virtual]`

Starts the threads running.

Thread 0 will be run by the thread that calls start_threads.

Implements sc::ThreadGrp.

int sc::ProcThreadGrp::wait_threads | ( |  | ) | `[virtual]`

Wait for all the threads to complete.

This must be called before start_threads is called again or the object is destroyed.

Implements sc::ThreadGrp.

ThreadGrp* sc::ProcThreadGrp::clone | ( | int | nthread = `-1` | ) | `[virtual]`

Create a ThreadGrp like the current one.

If nthread is given, the new ThreadGrp will attempt to support that number of threads, but the actual number supported may be less. If nthread is -1, the number of threads in the current group will be used.

Reimplemented from sc::ThreadGrp.

The documentation for this class was generated from the following file:

- thread.h